﻿using System.Runtime.InteropServices;
using JetBrains.Annotations;
using OpcLabs.BaseLibFactory;
using OpcLabs.EasyOpc.DataAccess.Connectivity;

namespace OpcLabs.EasyOpcFactory.DataAccess.Connectivity
{
    static public class DAItemPointWriteArgumentsInstances
    {
        [NotNull]
        static public DAItemPointWriteArguments Instance0 => new DAItemPointWriteArguments();

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1065:DoNotRaiseExceptionsInUnexpectedLocations")]
        [NotNull]
        static public DAItemPointWriteArguments Instance1
        {
            get
            {
                var itemPointWriteArguments = new DAItemPointWriteArguments 
                {
                    ErrorCode = -111,
                    Exception = new COMException("comException1", 112),
                    ErrorMessage = "errorMessage1",
                    Quality = DAQualityInstances.Instance1,
                    Timestamp = DateTimeUtcInstances.Kind_Utc,
                    TimestampLocal = DateTimeLocalInstances.Kind_Local,
                    Value = 2222.2f,
                    Vtq = DAVtqInstances.ADouble,
                };
                return itemPointWriteArguments;
            }
        }
    }
}
