﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA.OperationModel;

namespace OpcLabs.EasyOpcFactory.UA.OperationModel
{
    static public class EasyUADataChangeNotificationEventArgsInstances
    {
        [NotNull]
        static public EasyUADataChangeNotificationEventArgs Instance0 => new EasyUADataChangeNotificationEventArgs();

        [NotNull]
        static public EasyUADataChangeNotificationEventArgs Instance1 => new EasyUADataChangeNotificationEventArgs
        {
            ErrorCode = -1,
            ErrorMessage = "TestMessage1"
        };

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1065:DoNotRaiseExceptionsInUnexpectedLocations")]
        [NotNull]
        static public EasyUADataChangeNotificationEventArgs Instance2 => new EasyUADataChangeNotificationEventArgs
        {
            ErrorCode = -2,
            Exception = new COMException("TestMessage2"),
            Diagnostics = { new ApplicationException("Diagnostics1", new IOException("Diagnostics2")) }
        };

        [NotNull]
        static public EasyUADataChangeNotificationEventArgs Instance3 => new EasyUADataChangeNotificationEventArgs
        {
            Arguments = EasyUAMonitoredItemArgumentsInstances.Instance1
        };

        [NotNull]
        static public EasyUADataChangeNotificationEventArgs Instance4 => new EasyUADataChangeNotificationEventArgs
        {
            Arguments = EasyUAMonitoredItemArgumentsInstances.Instance1,
            AttributeData = UAAttributeDataInstances.Instance1
        };
    }
}
