﻿using System.Threading;
using JetBrains.Annotations;
using OpcLabs.BaseLib.ComInterop;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.AddressSpace;

namespace OpcLabs.EasyOpcLiveTest.DataAccess.Environment
{
    public class DAItemCatalogEntry : DANodeCatalogEntry
    {
        #region Public Constructors

        public DAItemCatalogEntry([NotNull] DANodeElement element) : base(element)
        {
            AccessRights = DAAccessRights.None;
            BehaviorKind = OpcItemBehaviorKind.Unknown;
            DataType = VarTypes.Empty;
            FastestRateOfChange = 0;
            Quality = 0;
            SlowestRateOfChange = Timeout.Infinite;
        }

        #endregion



        #region Public Properties

        [NotNull]
        public DAAccessRight AccessRights { get; set; }

        public OpcItemBehaviorKind BehaviorKind { get; set; }

        [NotNull]
        public VarType DataType { get; set; }

        public int FastestRateOfChange { get; set; }

        [NotNull]
        public DAQuality Quality { get; set; }

        public int SlowestRateOfChange { get; set; }

        [CanBeNull]
        public object Value { get; set; }

        #endregion



        #region Public Methods

        #endregion
    }
}
