﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.AlarmsAndEvents
{
    [TestClass]
    public class EasyAENotificationEventArgsTest
    {

        [Timeout(60 * 1000)]
        [TestCategory("BinarySerialization")]
        [TestCategory("Live")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void BinarySerializationTestLiveStream()
        {
            int handle = EasyAEClient.SharedInstance.SubscribeEvents("", LegacyTestDefs.ProgIds.KitEventServer, 100,
                (_, eventArgs) =>
                    // ReSharper disable AssignNullToNotNullAttribute
                        Tests.BinarySerializationTest(eventArgs));
            // ReSharper restore AssignNullToNotNullAttribute
            AssertUtilities.WaitingPhase(10 * 1000);
            EasyAEClient.SharedInstance.UnsubscribeEvents(handle);
        }

        [Timeout(60 * 1000)]
        [TestCategory("Live")]
        [TestCategory("TimeDomain")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestLiveStream()
        {
            int handle = EasyAEClient.SharedInstance.SubscribeEvents("", LegacyTestDefs.ProgIds.KitEventServer, 100,
                (_, eventArgs) =>
                    // ReSharper disable AssignNullToNotNullAttribute
                        Tests.XmlSerializationTest(eventArgs));
            // ReSharper restore AssignNullToNotNullAttribute
            AssertUtilities.WaitingPhase(10 * 1000);
            EasyAEClient.SharedInstance.UnsubscribeEvents(handle);
        }
    }
}
