﻿using System;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;

namespace OpcLabs.EasyOpcLiveTest.Legacy.DataAccess
{
    // ReSharper disable once InconsistentNaming
    public class IEasyDAClientTest_Com_BrowseAccessPaths : IEasyDAClientTestBase
    {
        public IEasyDAClientTest_Com_BrowseAccessPaths([NotNull] Func<IEasyDAClient> createClientFunc)
            : base(createClientFunc)
        {
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BrowseAccessPathsTest()
        {
            var target = CreateClient();

            string[] accessPathsArray = target.BrowseAccessPaths("", LegacyTestDefs.ProgIds.KitServer,
                                                                 LegacyTestDefs.DataAccess.ItemIds.Constant_I4);

            Assert.IsNotNull(accessPathsArray);
            Assert.AreEqual(2, accessPathsArray.Length);

            //TODO:

        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BrowseAccessPathsTest_ServerDescriptor()
        {
            var target = CreateClient();

            string[] accessPathsArray = target.BrowseAccessPaths(
                new ServerDescriptor("", LegacyTestDefs.ProgIds.KitServer), LegacyTestDefs.DataAccess.ItemIds.Constant_I4);

            Assert.IsNotNull(accessPathsArray);
            Assert.AreEqual(2, accessPathsArray.Length);

            //TODO:

        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BrowseAccessPathsTest_BrowsePath()
        {
            var target = CreateClient();

            string[] accessPathsArray = target.BrowseAccessPaths(
                new ServerDescriptor("", LegacyTestDefs.ProgIds.KitServer),
                new DANodeDescriptor(null, LegacyTestDefs.DataAccess.BrowsePaths.Constant_I4));

            Assert.IsNotNull(accessPathsArray);
            Assert.AreEqual(2, accessPathsArray.Length);

            //TODO:

        }
    }
}
