// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

namespace OpcLabs.EasyOpcLiveTest.Legacy
{
	static public class LegacyTestDefs
	{
        static public class DataTypes
        {
            static public short Invalid1 = -1;
            static public short Invalid2 = 3999;
        }

        static public class MachineNames
        {
            public const string OpcUaTest = "test-opc-3";
            public const string UnknownResource = "UnknownResource";
        }

        static public class ProgIds
        {
            // ReSharper disable InconsistentNaming
            public const string Item = "OPCLabs.Item";
            public const string KitEventServer = Legacy.Environment.OpcKitServer.KitEventServer.ProgId;
            public const string KitServer = Legacy.Environment.OpcKitServer.KitServer.ProgId;
            public const string TOPServer = "SWToolbox.TOPServer";
            public const string Unregistered = "ProgId.Unregistered";
            // ReSharper restore InconsistentNaming
        }

        static public class ServerClasses   // TODO: How does this differ from ProgIds?
        {
        }

        static public class Tags
        {
            public const string Some = "SomeTag";
        }

        /*
        public static class Sources // ErrorSources?
        {
            public const string EasyOpcDANet = "EasyOpcDANet";
        }
         * */



        static public class AlarmsAndEvents
        {
            static public class Areas
            {
                public const string Simulation = "Simulation";
            }

            static public class BrowsePaths
            {
                // ReSharper disable InconsistentNaming
                public const string ConditionState1 = "/Simulation/ConditionState1";
                public const string Regular_1min = "/Simulation/Regular (1 min)";
                // ReSharper restore InconsistentNaming
            }

            static public class Sources
            {
                // ReSharper disable InconsistentNaming
                public const string ConditionState1 = "Simulation.ConditionState1";
                public const string Regular_1min = "Simulation.Regular (1 min)";
                // ReSharper restore InconsistentNaming
            }
        }



        static public class DataAccess
        {
            static public class AccessPaths
            {
                public const string Some = "SomeAccess";
            }

            static public class BrowsePaths
            {
                // ReSharper disable InconsistentNaming
                public const string Constant_BOOL = "/Simulation/Constant_BOOL";
                public const string Constant_I4 = "/Simulation/Constant_I4";
                public const string Incrementing_1s = "/Simulation/Incrementing (1 s)";
                public const string Register_BOOL = "/Simulation/Register_BOOL";
                public const string Register_I4 = "/Simulation/Register_I4";
                // ReSharper restore InconsistentNaming
            }

            static public class ItemIds
            {
                // ReSharper disable InconsistentNaming
                public const string Command = "ServerControl.Command";
                //public const string Constant_ArrayOfI2 = "Simulation.Constant_ArrayOfI2";
                //public const string Constant_ArrayOfR4 = "Simulation.Constant_ArrayOfR4";
                //public const string Constant_ArrayOfR8 = "Simulation.Constant_ArrayOfR8";
                public const string Constant_BOOL = "Simulation.Constant_BOOL";
                public const string Constant_BSTR = "Simulation.Constant_BSTR";
                public const string Constant_I1 = "Simulation.Constant_I1";
                public const string Constant_I2 = "Simulation.Constant_I2";
                public const string Constant_I4 = "Simulation.Constant_I4";
                public const string Constant_R4 = "Simulation.Constant_R4";
                public const string Constant_R8 = "Simulation.Constant_R8";
                public const string Constant_UI1 = "Simulation.Constant_UI1";
                public const string Constant_UI2 = "Simulation.Constant_UI2";
                public const string Constant_UI4 = "Simulation.Constant_UI4";
                public const string Incrementing_1s = "Simulation.Incrementing (1 s)";
                public const string Random = "Simulation.Random";
                public const string Ramp_1s = "Simulation.Ramp (1 s)";
                public const string Register_ArrayOfI2 = "Simulation.Register_ArrayOfI2";
                public const string Register_ArrayOfR4 = "Simulation.Register_ArrayOfR4";
                public const string Register_ArrayOfR8 = "Simulation.Register_ArrayOfR8";
                public const string Register_BOOL = "Simulation.Register_BOOL";
                public const string Register_BSTR = "Simulation.Register_BSTR";
                public const string Register_I1 = "Simulation.Register_I1";
                public const string Register_I2 = "Simulation.Register_I2";
                public const string Register_I4 = "Simulation.Register_I4";
                public const string Register_R4 = "Simulation.Register_R4";
                public const string Register_R8 = "Simulation.Register_R8";
                public const string Register_UI1 = "Simulation.Register_UI1";
                public const string Register_UI2 = "Simulation.Register_UI2";
                public const string Register_UI4 = "Simulation.Register_UI4";
                public const string UnknownItem = "UnknownItem";
                // ReSharper restore InconsistentNaming
            }
        }
	}

}
