﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpcLiveTest.Legacy.UA.Environment;
using OpcLabs.EasyOpcLiveTest.UA.Environment;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA
{
    public partial class EasyUAClientTest
    {
        public partial class Endpoint
        {
            #region Public Constructors

            public Endpoint([NotNull] UAEndpointDescriptor endpointDescriptor)
            {
                EndpointDescriptor = endpointDescriptor;
            }

            #endregion



            #region Public Properties

            [NotNull]
            UAEndpointDescriptor EndpointDescriptor { get; }

            #endregion



            #region Private Properties

            [NotNull]
            private LegacyUATestEnvironment TestEnvironment => LegacyUATestEnvironment.Current;

            #endregion



            #region Private Methods

            #endregion
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyUAClientTest_Endpoint_SampleServer_Http : Endpoint
        {
            public EasyUAClientTest_Endpoint_SampleServer_Http()
                : base(LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.Http)
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyUAClientTest_Endpoint_SampleServer_OpcTcp : Endpoint
        {
            public EasyUAClientTest_Endpoint_SampleServer_OpcTcp()
                : base(LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp)
            {
            }
        }
    }
}
