﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA
{
    /// <summary>
    ///This is a test class for EasyUAClientTest and is intended
    ///to contain all EasyUAClientTest Unit Tests
    ///</summary>
    public partial class EasyUAClientTest
    {
        #region Test Methods

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest2()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget2());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest2()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget2());
        }

        #endregion



        #region Private Methods

        [NotNull]
        private EasyUAClient CreateSerializationTarget0()
        {
            return new EasyUAClient();
        }

        [NotNull]
        private EasyUAClient CreateSerializationTarget1()
        {
            var client = new EasyUAClient
            {
                Isolated = true,
                InstanceParameters = {  DiscoveryHost = "127.0.0.1" },
            };
            return client;
        }

        [NotNull]
        private EasyUAClient CreateSerializationTarget2()
        {
            var client = new EasyUAClient
            {
                IsolatedParameters = {
                    DiscoveryParameters = { DiscoveryTimeout = 55},
                    MonitoredItemParameters = { RetrialDelay = 11 },
                    SessionParameters = { CloseTimeout = 22 },
                    SubscriptionParameters = { RetrialDelay = 33 },
                }
            };
            return client;
        }

        #endregion
    }
}
