﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib;
using OpcLabs.BaseLib.Execution;
using OpcLabs.BaseLib.OperationModel;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess
{
    partial class EasyDAClientTest
    {
        [Ignore]    // IMPROVE: fails
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void ChangeSomeSharedParameterTest()
        {
            int oldValue = EasyDAClient.SharedParameters.EngineParameters.ClientLruSize;
            AssertUtilities.WriteLine(oldValue);
            using (new StaticEnvironment())
            {
                int newValue = oldValue ^ 1;
                AssertUtilities.WriteLine(newValue);
                EasyDAClient.SharedParameters.EngineParameters.ClientLruSize = newValue;
                Assert.AreEqual(newValue, EasyDAClient.SharedParameters.EngineParameters.ClientLruSize);

                // do some operation
                try
                {
                    object value = new EasyDAClient().ReadItemValue("aServer", "Demo.Ramp");
                    AssertUtilities.WriteLine(value);
                }
                catch (OperationException e)
                {
                    Console.WriteLine(e);
                }
            }
            Assert.AreEqual(oldValue, EasyDAClient.SharedParameters.EngineParameters.ClientLruSize);
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void DefaultValueTest_ServiceProviderEndpointDescriptor()
        {
            EndpointDescriptor endpointDescriptor = EasyDAClient.ServiceProviderEndpointDescriptor;
            Assert.IsNotNull(endpointDescriptor);
            AssertUtilities.WriteLine(endpointDescriptor);
            Assert.IsFalse(endpointDescriptor.IsNull);
        }
           
    }
}
