﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.AddressSpace;
using OpcLabs.EasyOpcFactory.DataAccess.AddressSpace;

namespace OpcLabs.EasyOpcTest.DataAccess
{
    partial class DANodeDescriptorTest
    {
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void CtorTest_DANodeElement_Instance0()
        {
            DANodeElement nodeElement = DANodeElementInstances.Instance0;
            var nodeDescriptor = new DANodeDescriptor(nodeElement);

            Assert.AreEqual(nodeElement.BrowsePath, nodeDescriptor.BrowsePath);
            Assert.AreEqual(nodeElement.ItemId, nodeDescriptor.ItemId);
            Assert.AreEqual(nodeElement.ItemId, nodeDescriptor.NodeId);
            Assert.AreEqual(nodeElement.NodePath, nodeDescriptor.NodePath);
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void CtorTest_DANodeElement_Instance2()
        {
            DANodeElement nodeElement = DANodeElementInstances.Instance2;
            var nodeDescriptor = new DANodeDescriptor(nodeElement);

            Assert.AreEqual(nodeElement.BrowsePath, nodeDescriptor.BrowsePath);
            Assert.AreNotSame(nodeElement.BrowsePath, nodeDescriptor.BrowsePath);
            Assert.AreEqual(nodeElement.ItemId, nodeDescriptor.ItemId);
            Assert.AreEqual(nodeElement.ItemId, nodeDescriptor.NodeId);
            Assert.AreEqual(nodeElement.NodePath, nodeDescriptor.NodePath);
        }
    }
}
