﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.Engine;
using OpcLabs.EasyOpcFactory.UA.Engine;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.Engine
{
    public partial class EasyUAEngineParametersTest
    {
        #region Test Methods

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        #endregion


        [NotNull]
        static public EasyUAEngineParameters CreateSerializationTarget0()
        {
            return new EasyUAEngineParameters();
        }

        [NotNull]
        static public EasyUAEngineParameters CreateSerializationTarget1()
        {
            return new EasyUAEngineParameters(UASmartEngineParametersInstances.Instance1)
                {
                    AutomaticPublishingFactor = 3.001f,
                    FastestAutomaticPublishingInterval = 3002,
                };
        }
    }
}
