﻿using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Reflection;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.Toolkit.Diagnostics;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.Toolkit.Diagnostics
{
    [TestClass]
    public class UAEngineEventIdsTest
    {
        [TestCategory("OpcUA")]
        [TestMethod]
        public void UniquenessTest()
        {
            List<FieldInfo> literals = typeof (UAEngineEventIds)
                .GetFields(BindingFlags.Static | BindingFlags.Public)
                // ReSharper disable PossibleNullReferenceException
                .Where(f => f.IsLiteral)
                // ReSharper restore PossibleNullReferenceException
                .ToList();
            AssertUtilities.WriteLine(literals.Count);
            List<IGrouping<object, FieldInfo>> duplicates = literals
                // ReSharper disable PossibleNullReferenceException
                .GroupBy(f => f.GetRawConstantValue())
                // ReSharper restore PossibleNullReferenceException
                // ReSharper disable AssignNullToNotNullAttribute
                .Where(g => g.Count() > 1)
                // ReSharper restore AssignNullToNotNullAttribute
                .ToList();

            foreach (IGrouping<object, FieldInfo> fieldInfos in duplicates)
            {
                // ReSharper disable PossibleNullReferenceException
                Trace.Write(fieldInfos.Key);
                Trace.Write(":");
                foreach (FieldInfo fieldInfo in fieldInfos)
                {
                    Trace.Write(" ");
                    Trace.Write(fieldInfo.Name);
                }
                AssertUtilities.WriteLine("");
                // ReSharper restore PossibleNullReferenceException
            }

            Assert.IsTrue(!duplicates.Any());
        }
    }
}
