﻿
using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace;
using OpcLabs.EasyOpc.UA.Engine;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.EasyOpc.UA.Toolkit.ClientServer;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA
{
    public partial class EasyUAClientTest
    {
        #region Test Methods
        // ReSharper disable InconsistentNaming

        [TestCategory("OpcUA")]
        [TestMethod]
        public void ReadValueTest_InvalidUrlFormat()
        {
            TestSection.Arrange();
            var target = new EasyUAClient();
            var endpointDescriptor = new UAEndpointDescriptor { UrlString = "!@#$%^&*()" };
            UANodeId nodeId = "i=1";

            try
            {
                TestSection.Act();
                try
                {
                    target.ReadValue(endpointDescriptor, nodeId);
                }
                finally
                {
                    TestSection.Assert();
                }
            }
            catch (UAException uaException)
            {
                Exception innerException1 = uaException.InnerException;
                Assert.IsNotNull(innerException1);
                var clientEngineException = innerException1 as UAClientEngineException;
                Assert.IsNotNull(clientEngineException);
                Assert.AreEqual(UAClientErrorCodes.EndpointSelectionDiscoveryUrlInvalid, clientEngineException.ErrorCode);
                Exception innerException2 = clientEngineException.InnerException;
                Assert.IsNotNull(innerException2);
                var uriFormatException = innerException2 as UriFormatException;
                Assert.IsNotNull(uriFormatException);
                return;
            }
            Assert.Fail();
        }


        // ReSharper restore InconsistentNaming
        #endregion
    }
}
