﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Implementation;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class OpcFoundation_UASampleServer_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] {"nsu=http://test.org/UA/Data/;ns=2;i=10468"};

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] {"nsu=http://test.org/UA/Data/;ns=2;i=10468"};

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=http://test.org/UA/Data/;ns=2;i=10853",
            "nsu=http://test.org/UA/Data/;ns=2;i=10849"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => EasyUADefinitions
            // ReSharper disable once AssignNullToNotNullAttribute
            .GetUASampleServerEndpointUrlStrings(EasyUADefinitions.DemoHost).Select(s => new UAEndpointDescriptor(s));

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),    // cannot conveniently make the demo server trust us
            nameof(Group001_Session_Test08_CreateSession_InstanceCertificate),    // cannot conveniently make the demo server trust us
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
        });

        public override string Password => "123";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] {"nsu=http://test.org/UA/Data/;ns=2;i=10393"};

        public override string UserName => "OpcUser1";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] {"nsu=http://test.org/UA/Data/;ns=2;i=10389"};
    }
}
