﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class Siemens_WinCC_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[0];

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[0];

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:WinCC01:Siemens.Automation.WinCC;ns=1;s=t|dyn_VT_R4_Float32Bit",
            "nsu=urn:WinCC01:Siemens.Automation.WinCC;ns=1;s=t|dyn_VT_R8_Float64Bit"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://wincc01:4862" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group002_ViewServices_Test07_TranslateBrowsePathToNodeId_Components),
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group009_DataChange_Test05_AbsoluteDeadbandFilter),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "opcuauser";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=urn:WinCC01:Siemens.Automation.WinCC;ns=1;s=t|stat_VT_I4_Signed32Bit" };

        public override string UserName => "opcuauser";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "nsu=urn:WinCC01:Siemens.Automation.WinCC;ns=1;s=t|stat_VT_I4_Signed32Bit" };
    }
}
